#include <stdio.h>
#include "mysystem.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include "readfile.h"

extern int errno;

/* modules.autoload format (to be easy): every line that shall be interpreted has a colon.
comment part of a line with an octothorpe.
*/


int automod() {
	printf("Loading modules...\n");
	char *buf = readfile("/etc/snailit/modules.autoload");
	int len = strlen(buf);
	char *oldbuf = buf;
	int i = 0; //apparently, it would be a lot easier to use an index rather than incrementing the pointer :D
	int j;
	char line[len];
	int lindex = 0;
	pid_t pid;
	while (i < len) { //main program loop - run through the file until done.
		if (buf[i] == ':') {
			//do stuff
			//printf("%s\n", buf);
			
			while (buf[i] != '\n' && buf[i] != '\0') {
				line[lindex] = buf[i];
				lindex++;
				i++;
			}
			line[lindex] = '\0';
		}
		else {
			//if it's not colon, jump to next line.
			while (buf[i] != '\n' && buf[i] != '\0') {
				i++;
			}
		}
		if (lindex) {
			char command[128];
			sprintf(command, "/sbin/modprobe ");
			for (j = 1; line[j] != '#' && line[j] != '\n' && line[j] != '\0'; j++)
				command[14+j] = line[j];
			command[14+j] = '\0';
			printf("Executing %s\n", command);
			mysystem(command, NULL, 0, 1);
			lindex = 0;
		}
		i++; // don't start on newline
		//fprintf(stderr, "buf[%i] = %c\n", i, buf[i]);
	}
	//AFTER everything else...
	buf = oldbuf;
	free(buf);
	return 0;
}
